local Proxy = module("vrp", "lib/Proxy")
local Tunnel = module("vrp", "lib/Tunnel")
local vRP = Proxy.getInterface("vRP")
local vRPclient = Tunnel.getInterface("vRP", "vrp_biju")
local possibleWins = {}

Citizen.CreateThread(function()
	vRP.defInventoryItem{"biju_poseta", "Poseta cu Diamante", "Poseta furata din magazinul de bijuterii", nil, 0.5};
	vRP.defInventoryItem{"biju_colier", "Colier cu Diamante", "Colier furat din magazinul de bijuterii",nil, 0.5};
	vRP.defInventoryItem{"biju_cercei", "Cercei cu Diamante", "Cercei furati din magazinul de bijuterii", nil, 0.5};
	vRP.defInventoryItem{"biju_bratara", "Bratara cu Diamante", "Bratara furata din magazinul de bijuterii", nil, 0.5};
	vRP.defInventoryItem{"biju_diadema", "Bratara cu Diadema", "Bratara furata din magazinul de bijuterii", nil, 0.5};
	vRP.defInventoryItem{"biju_inel", "Inel cu Diamante", "Inel furat din magazinul de bijuterii.", nil, 0.5};
end)

Citizen.CreateThread(function() -- load wins table
	for key, data in pairs(module("vrp", "cfg/item/jafbiju")) do
		possibleWins[#possibleWins+1] = {
			item = key,
			price = data.price or 1,
		}
	end
end)

local lastRobbery
local activeRobbery = false
local robSecret = {}

RegisterServerEvent("vrp-biju:startRobbing")
AddEventHandler("vrp-biju:startRobbing", function()
	local player = source
	local user_id = vRP.getUserId({player})
	if not user_id then return DropPlayer(player, "Reconecteaza-te pe server!") end

	local uFaction = vRP.getUserFaction{user_id};
	local uFactionType = vRP.getFactionType{uFaction};
	if not (uFactionType == 'Mafie' or uFactionType == "Gang") then return vRPclient.notify(player, {"Nu poti sa dai jaf deoarece nu esti intr-o mafie / gang!",5000}) end;

	if (lastRobbery or 0) <= os.time() then

		local copUsers = vRP.getOnlineUsersByFaction({"Politie"})
		if #copUsers <= 7 then
			return vRPclient.notify(player, {"Nu sunt suficienti politisti online! Minimul este de 7, iar momentan sunt doar "..#copUsers.. " !"})
		end

		lastRobbery = os.time() + 36000 -- 1 ora cooldown
		activeRobbery = true

		TriggerClientEvent("vrp-biju:setState", -1, false)
		local newSecret = math.random(1, user_id) + ((os.time() % 60) + 1)
		robSecret[user_id] = newSecret

		TriggerClientEvent("vrp-biju:sendCoords", player, {newSecret})

		for i=1,3 do
			TriggerClientEvent('chatMessage', -1, '^1[ALERT] ^0Un jaf este acum in desfasurare la magazinul de bijuterii^0');
		end

		return
	end

	local remainingTime = lastRobbery - os.time()
	vRPclient.notify(player, {"Trebuie sa mai astepti "..remainingTime.." (de) secunde inainte de a jefuii iar bijuteria!",})
end)

RegisterServerEvent("vrp-biju:cancelRob")
AddEventHandler("vrp-biju:cancelRob", function()
	local player = source
	local user_id = vRP.getUserId({player})

	robSecret[user_id] = nil
	activeRobbery = false
	TriggerClientEvent("vrp-biju:setState", -1, not activeRobbery)
end)

RegisterServerEvent("vrp-biju:robCoords")
AddEventHandler("vrp-biju:robCoords", function(cpData)
	local player = source
	local user_id = vRP.getUserId({player})

	if not robSecret[user_id] or (robSecret[user_id] ~= cpData[1]) then
		-- return vRP.banPlayer(0, user_id, -1, "Injection detected [vrp_biju]")
		return DropPlayer(player, "Young nigga!");
	end

	local rnd = table.rnd(possibleWins)
	local amt = math.random(1, 3)
	
	vRP.giveInventoryItem({user_id, rnd.item, amt, true})
end)

RegisterServerEvent("vrp-biju:sellJewels")
AddEventHandler("vrp-biju:sellJewels", function()
	local player = source
	local user_id = vRP.getUserId({player})
	local cashWin = 0

	for _, item in pairs(possibleWins) do
		local amt = vRP.getInventoryItemAmount({user_id, item.item})

		if (amt > 0) and vRP.tryGetInventoryItem({user_id, item.item, amt, true}) then
			cashWin = cashWin + (amt * item.price)
		end
	end

	if cashWin > 0 then
		vRP.giveMoney({user_id, cashWin});
		-- vRP.giveInventoryItem({user_id, "bani_murdari", cashWin, true})
		return
	end

	vRPclient.notify(player, {"Nu ai bijuterii sa-mi vinzi, pleaca de aici mai repede!", "error", false, "fas fa-face-frown"})
end)

AddEventHandler("vRP:playerSpawn", function(user_id, source,fs)
	if not fs then return end;
	TriggerClientEvent("vrp-biju:setState", source, (not activeRobbery))
end)

AddEventHandler("vRP:playerLeave", function(user_id)
	if robSecret[user_id] then
		robSecret[user_id] = nil
	end
end)